int dbw_init(void);
void *dbw_lookup(const char *name);

struct database_world_operations {
  const char *name;

  db_t *(*create)(const char *name);
  void (*destroy)(db_t *world);

  int (*add)(db_t *world, int key, void *value);
  int (*remove)(db_t *world, int key);

  void *(*lookup)(db_t *world, int key);
  int (*size)(db_t *world);
};

/* Private */

#define DBW_DECLARE(type, name)	\
	db_t *type##_create(const char *dbname);	\
	void type##_destroy(db_t *world);		\
	int type##_add(db_t *world, int key, void *value);	\
	int type##_remove(db_t *world, int key);	\
	void *type##_lookup(db_t *world, int key);	\
	int type##_size(db_t *world);			\
							\
	struct database_world_operations dbw_##type = {	\
		name,					\
		type##_create, type##_destroy,		\
		type##_add, type##_remove,		\
		type##_lookup, type##_size		\
	}

#define DBW_REGISTER(type)	\
	do {	\
	extern struct database_world_operations dbw_##type;	\
	handler_register(dbw_index, &dbw_##type);		\
	} while (0)
