/*
 * dfp.c - Data file parsers.  Grok data returned from dio.
 *	- Boot-time side.
 */
#include "fuzzy.h"
#include "dfp.h"
#include "dbf.h"	/* DBF_ constants. */
#include "register.h"

/* Private */
static HandlerList *dfp_index;

int dfp_init(void)
{
  dfp_index = handler_list_create();

  /* Insert new data formats below. */

  DFP_REGISTER(circle);

  /* New data formats go above. */
  return TRUE;
}

void *dfp_lookup(const char *name)
{
  return handler_lookup(dfp_index, name);
}

/* Simple number->name splitter if you don't like dfp->parse_by.XXX */
int dfp_parse(World *world, struct data_parser_operations *dfp, int type, char **data)
{
#if 1
  switch (type) {
  case DBF_MOBILE:
    return dfp->parse_by.type.mobile(world, data);
  case DBF_OBJECT:
    return dfp->parse_by.type.object(world, data);
  case DBF_ROOM:
    return dfp->parse_by.type.room(world, data);
  case DBF_SHOP:
    return dfp->parse_by.type.shop(world, data);
  case DBF_ZONE:
    return dfp->parse_by.type.zone(world, data);
  default:
    return 0;
  }
#else
  return dfp->parse_by.num[type](world, data);
#endif
}

