/* Public */

char *sread(char **data, char *terminator);
char *sread_line(char **data);
char *sread_string(char **data);
char *sread_all(char **data);

typedef void DIO;

int dio_init(void);
void *dio_lookup(const char *name);
DIO *dio_open(const char *name, char *path);
char *dio_data(DIO *handle);
void dio_close(DIO *handle);

struct data_io_operations {
  const char *name;
  DIO *(*open)(char *name);
  char *(*data)(DIO *);
  void (*close)(DIO *);
};

/* Private */

#define DIO_DECLARE(type, name)	\
	DIO *dio_##type##_open(char *);	\
	char *dio_##type##_data(DIO *);	\
	void dio_##type##_close(DIO *);	\
					\
	struct data_io_operations dio_##type##_ops = {	\
		name,			\
		dio_##type##_open,	\
		dio_##type##_data,	\
		dio_##type##_close	\
	}

#define DIO_REGISTER(type)	\
	do {	\
	extern struct data_io_operations dio_##type##_ops;	\
	handler_register(dio_index, &dio_##type##_ops);	\
	} while (0)
