/*
 * fread() file io.
 */
#include <unistd.h>
#include "fuzzy.h"
#include "dio.h"

DIO_DECLARE(read, "read syscall");

struct dio_read_internal {
  int fd;
  char *buf;
};

DIO *dio_read_open(char *path)
{
  struct dio_read_internal *readi;
  int fd;

  if ((fd = open(path, O_RDONLY)) < 0)
    return NULL;

  readi = g_new0(struct dio_read_internal, 1);
  readi->fd = fd;

  return readi;
}

char *dio_read_data(DIO *data)
{
  struct stat statbuf;
  struct dio_read_internal *readi = (struct dio_read_internal *)data;

  if (readi->buf)
    return readi->buf;

  if (fstat(readi->fd, &statbuf) < 0)
    return NULL;

  readi->buf = g_new0(char, statbuf.st_size + 1);
  read(readi->fd, readi->buf, statbuf.st_size);
  return readi->buf;
}

void dio_read_close(DIO *data)
{
  struct dio_read_internal *readi = (struct dio_read_internal *)data;

  close(readi->fd);
  if (readi->buf)
    g_free(readi->buf);
  g_free(readi);
}
