/*
 * Generic read-data-from-SQL type thing.
 * Currently a thin wrapper over DBD.
 */
#include "fuzzy.h"
#include "dio.h"
#include "dbd.h"
#include "options.h"

DIO_DECLARE(sql, "SQL");

struct options_list dio_sql_options[] = {
  { "driver", NULL },
  { NULL,     NULL }
};

DIO *dio_sql_open(char *path)
{
  DBD *dbdval;
  char *pathval, *rest;

  pathval = g_strdup(path);
  rest = parse_options(pathval, dio_sql_options);
  dbdval = dbd_open(dio_sql_options[0].value, rest);
  free_options(dio_sql_options);
  g_free(pathval);
  return dbdval;
}

char *dio_sql_data(DIO *data)
{
  return dbd_data(data);
}

void dio_sql_close(DIO *data)
{
  dbd_close(data);
}
