#include "fuzzy.h"
#include "mlog.h"

#define DLOG_COLUMN	35
#define strvalof(y)	g_string(y)

/*
 * Sort of g_log() compatible.
 */
int mlog(int level, int priority, const char *format, ...)
{
  va_list args;

  va_start(args, format);
  vfprintf(stderr, format, args);
  va_end(args);

  fputc('\n', stderr);

  return TRUE;
}

/* Temporary.  Merge with above? */
int debuglog(const char *file, int line, const char *function, const char *format, ...)
{
  char prefix[DLOG_COLUMN];
  va_list args;

  g_snprintf(prefix, sizeof(prefix), "%s:%d (%s)", file, line, function);
  fprintf(stderr, "%-" strvalof(DLOG_COLUMN) "s -- ", prefix);

  va_start(args, format);
  vfprintf(stderr, format, args);
  va_end(args);

  fputc('\n', stderr);

  return TRUE;
}
