#include "fuzzy.h"
#include "register.h"

HandlerList *handler_list_create(void)
{
  return g_ptr_array_new();
}

int handler_register(HandlerList *list_head, void *handler)
{
  dlog("%p registered '%s'", list_head, *(char **)handler);
  g_ptr_array_add(list_head, handler);
  return TRUE;
}

int handler_unregister(HandlerList *list_head, void *handler)
{
  dlog("%p unregistered '%s'", list_head, *(char **)handler);
  return g_ptr_array_remove(list_head, handler);
}

/*
 * Name of handler must be first in a char * field.
 */
void *handler_lookup(HandlerList *list_head, const char *text)
{
  int pos;

  if (!text || !*text)
    dlog("null or empty text: %p", text);

  if (!text || !*text || !g_strcasecmp(text, "default"))
    return g_ptr_array_index(list_head, 0);

  for (pos = 0; g_ptr_array_index(list_head, pos); pos++)
    if (!g_strcasecmp(*(char **)g_ptr_array_index(list_head, pos), text))
      return g_ptr_array_index(list_head, pos);

  return NULL;
}
