#include "fuzzy.h"
#include "dio.h"
#include "dbd.h"
#include "dfp.h"
#include "dbf.h"
#include "dbw.h"

void dio_test_mysql(void)
{
  DIO *dio;
  char *text, *orig;
  const char *path = 	"Driver: MySQL\n"
			"\n"
			"SELECT file FROM roomfiles WHERE number='1200'\n"
			"\n"
			"Username: root\n"
			"Password: foobar\n"
			"Database: circle\n"
			"UnixSocket: /var/lib/mysql/mysql.sock\n"
			"\n"
			"DBD doesn't use this spot.\n";

  if (!(dio = dio_open("SQL", (orig = g_strdup(path)))))
    dlog("no dio");
  if (!(text = dio_data(dio)))
    dlog("no data");
  else
    dlog("MySQL length: %d", strlen(text));
  dio_close(dio);
  g_free(orig);
}

void dio_test_files(void)
{
  DIO *dio;
  int i;
  char *text, *orig;
  const char *types[] = { "mmap syscall", "fread stdio", "read syscall", NULL };
  const char *path = "test.c";

  orig = g_strdup(path);
  for (i = 0; types[i]; i++) {
    dlog("testing: %s", types[i]);
    if (!(dio = dio_open(types[i], orig)))
      dlog("%s: no dio", types[i]);
    if (!(text = dio_data(dio)))
      dlog("%s: no data", types[i]);
    else
      dlog("%s: length: %d", types[i], strlen(text));
    dio_close(dio);
  }
  g_free(orig);
}

int main(void)
{
  dio_init();
  dbd_init();
  dfp_init();
  dbw_init();
  dbf_init();

  dio_test_mysql();
  dio_test_files();
  return 1;
}
