#include "fuzzy.h"
#include "utils.h"

void strip_comments(char *line, unsigned int strip_v)
{
  int read, write, escape = FALSE;

  if (!strip_v)
    return;

  for (read = 0, write = 0; line[read]; read++) {
    if (escape) {
      line[write++] = line[read];
      escape = FALSE;
      continue;
    }

    switch (line[read]) {
    case '#':
      if (strip_v & CMT_SHELL) {
        while (line[read] != '\n')
          read++;
        break;
      }
      line[write++] = line[read];
      break;
    case '\\':
      escape = TRUE;
      break;
    case '/':
      if ((strip_v & CMT_CPP) && line[read + 1] == '/') {
        while (line[read] && line[read] != '\n')
          read++;
        break;
      }

      if ((strip_v & CMT_C) && line[read + 1] == '*') {
        while (line[read]) {
          if (line[read] != '*')
            read++;
          else if (line[read + 1] != '/')
            read += 2;
          else {
            read += 2;
            break;
          }
        }
      }
    default:
      line[write++] = line[read];
      break;
    }
  }
  line[write] = '\0';
}
